containername=unifi_cams_snapshot	#Name of the created docker container
deviceIP="192.168.10.1"				#Ip adress of your UniFi Device
deviceUsername="cmoehler"			#Username of LOCAL UniFi user
devicePassword="GuruBonny4039$"		#Password of LOCAL UniFi user
saveTarget="/volume1/docker/UniFiProtectFootage/Snapshots" #Target file path where the images will be saved
timeZone="Europe/Paris"
#============== NO CHANGES BEOW THIS LINE ==========================

allCams=true
firstCam=true
noSubFolders=true
cams=""

while [ $# -gt 0 ]       #until parameter amount ($#) bigger then 0
	do
		if [ $1 = "--subfolders" ]
		then
			noSubFolders=false
		elif [ $1 = "--help" ]
		then
			echo
			echo "Usage: snapshot_unifi_cams.sh [CAMS] [OPTIONS]..."
			echo
			echo "OPTIONS:"
			echo "--help          Show this message and exit."
			echo "--subfolders    Images will be put in subfolder yerr/month/day/cam/"
			echo
			echo "CAMS:           (if empty, snapsots from all cams will be taken)"
			echo "Camera ID       e.g. 62d2f99003a7b303e70003zr (multible \"Camera IDs\" as seperate parameter)"
			echo
			echo "============================"
			echo "=        EXAMPELS          ="
			echo "============================"
			echo "  snapshot_unifi_cams.sh 2d2f99003a7b303e70003zr 2d2f99003a7b303e78703zr --subfolders"
			echo "... will take snapshots from both specifide cameras and puts the image files in subfolders"
			echo
			echo "  snapshot_unifi_cams.sh"
			echo "... will take snapshots from all available cameras and puts all the images into the same folder"
			echo
			exit 0
		else
			allCams=false 		 #minimum one parameter present
			if [ $firstCam = true ]
				then
					cams=$1
					firstCam=false
				else
					cams+=,$1
			fi
		fi
	shift                  #move parameters $2->$1, $3->$2, $4->$3,...
done

echo ===============================
echo Starting UniFi Protect Snapshot
echo ===============================
date
if [ $allCams = true ]
then
	echo All cams
	cams=all
else
	echo Specific cam\(s\)\ $cams
fi

if [ $noSubFolders = true ]
then
	docker run -e TZ=$timeZone --name=$containername --volume $saveTarget:/downloads unifitoolbox/protect-archiver download --address=$deviceIP --username=$deviceUsername --password=$devicePassword --cameras=$cams --snapshot --no-use-subfolders --touch-files /downloads
else
	docker run -e TZ=$timeZone --name=$containername --volume $saveTarget:/downloads unifitoolbox/protect-archiver download --address=$deviceIP --username=$deviceUsername --password=$devicePassword --cameras=$cams --snapshot --touch-files /downloads
fi	

echo removing Docker container ...
docker container rm "$containername"
echo all done
